unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ExtCtrls, process;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button6: TButton;
    Button8: TButton;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Memo1: TMemo;
    SaveDialog1: TSaveDialog;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDropFiles(Sender: TObject; const FileNames: array of String);
    procedure Memo1Change(Sender: TObject);
    procedure Timer1StartTimer(Sender: TObject);
    procedure Timer1StopTimer(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
    AProcess : TProcess;
    pdfFileName : String;
    batFileName : String;
    function GetSpecialFolderPath(folder : integer) : string;
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{ TForm1 }
uses shfolder,windows;

function TForm1.GetSpecialFolderPath(folder : integer) : string;
 //unit shfolder !
 const
   SHGFP_TYPE_CURRENT = 0;
 var
   path: array [0..MAX_PATH] of char;
 begin
   if SUCCEEDED(SHGetFolderPath(0,folder,0,SHGFP_TYPE_CURRENT,@path[0])) then
     Result := path
   else
     Result := '';
 end;

procedure TForm1.Button6Click(Sender: TObject);
var
   s : string;
begin
     s:=ExtractShortPathNameUTF8(ExtractFilePath(Application.ExeName)+'pdfconcat.pdf')+#0;
     shellExecute(0,nil,@s[1],nil,nil,0);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Memo1.Lines.Clear;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
   i : integer;
   s,t : string;
   stl : TStringList;
begin
   if SaveDialog1.Execute then begin
      pdfFileName:=SaveDialog1.FileName;
      //showMessage(pdfFileName);
      if Memo1.Lines.Count=0 then begin
        ShowMessage('(1-) Il faut une liste de fichiers à concaténer !');
        exit;
      end;
      Label2.Caption:= 'dans '+SaveDialog1.FileName;
      batFileName:=ExtractFilePath(Application.ExeName)+'pdfconcat.bat';
      stl:=TStringList.Create;
      stl.add('En attente ... pour pdfconcat');
      stl.saveToFile(pdfFileName);
      //
      stl.Clear;
      stl.delimiter:=' ';
      stl.add('@pdftk.exe');
      for i:=0 to Memo1.Lines.count-1 do begin
          stl.add(ExtractShortPathNameUTF8(Memo1.Lines[i]));
      end;
      stl.add('output');
      stl.add(ExtractShortPathNameUTF8(pdfFileName));
      //
      t:=stl.delimitedtext;
      stl.Clear;
      //
      stl.add('@echo Patience : le regroupement PDF est en cours ...');
      stl.add(t);
      stl.SaveToFile(batFileName);
      stl.free;
      //
      Application.ProcessMessages;
      Timer1.Enabled:=true;
      //Process ...  voir Timer
   end;
end;


procedure TForm1.Button8Click(Sender: TObject);
begin
     shellExecute(0,nil,'http://emmanuel.ostenne.free.fr/util.htm#KeopsPDFConcat',nil,nil,0);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    SaveDialog1.InitialDir:=GetSpecialFolderPath( CSIDL_PERSONAL );
    SaveDialog1.FileName:='allconcat.pdf';
    Label2.Caption:='';
end;

procedure TForm1.FormDropFiles(Sender: TObject; const FileNames: array of String  );
var
  i : integer;
  s : string;
begin
    for i:=0 to length(FileNames)-1 do begin
        s:=FileNames[i];
        Memo1.Lines.add(s);
    end;
end;


procedure TForm1.Memo1Change(Sender: TObject);
begin
  Label1.caption:='1- Liste des fichiers à rassembler : (par glisser-lâcher)  - '+inttostr(Memo1.Lines.count)+' -';
end;

procedure TForm1.Timer1StartTimer(Sender: TObject);
begin
     Label7.Visible:=true;
     Label7.Caption:='En cours ...';
     Label7.Font.color:=clMaroon;
     Button1.Enabled:=false;
     Button2.Enabled:=false;
     Memo1.Enabled:=false;

         AProcess:=TProcess.Create(nil);
         {$IFDEF WIN32}
         AProcess.CommandLine := batFileName;
         AProcess.Options := AProcess.Options; // + [poWaitOnExit];
         AProcess.ShowWindow := swoMinimize;
         {$ENDIF}
         AProcess.Execute;
end;

procedure TForm1.Timer1StopTimer(Sender: TObject);
var s : string;
begin
     AProcess.Free;
     if CheckBox1.Checked then begin
        s:=ExtractShortPathNameUTF8(pdfFileName)+#0;
        shellExecute(0,nil,@s[1],nil,nil,0);
     end;
     Button1.Enabled:=true;
     Button2.Enabled:=true;
     Memo1.Enabled:=true;
     Label7.Font.color:=clMaroon;
     Label7.Caption:='Terminé.';
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
    if not AProcess.Running
       then Timer1.Enabled:=false
       else if Label7.Font.color=clMaroon
              then Label7.Font.color:=clRed
              else Label7.Font.color:=clMaroon
end;


initialization
  {$I unit1.lrs}

end.

